<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Caesar!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>
    <section>
        <title>
            <type>double **</type> háromszögmátrix</title>
        <para>
            Írj egy olyan <function>malloc</function> és <function>free</function>
            párost használó C programot, amely helyet foglal
            egy alsó háromszög mátrixnak a szabad tárban!
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/1MRTuKwRsB0">https://youtu.be/1MRTuKwRsB0</link>,
            <link xlink:href="https://youtu.be/RKbX5-EWpzA">https://youtu.be/RKbX5-EWpzA</link>.
        </para>
        <para>
            Megoldás forrása: 
        </para>
        <para>
            Forráskód linkje: <link xlink:href="https://gitlab.com/tamas.simon12/bhax/blob/master/Forrasok/4.%20Fejezet/tm.c">../bhax/blob/master/Forrasok/4.%20Fejezet/tm.c</link>
        </para> 
       

        <programlisting language="c"><![CDATA[#include <stdio.h>
#include <stdlib.h>

int
main ()
{
    int nr = 5;
    double **tm;

    if ((tm = (double **) malloc (nr * sizeof (double *))) == NULL)
    {
        return -1;
    }

    for (int i = 0; i < nr; ++i)
    {
        if ((tm[i] = (double *) malloc ((i + 1) * sizeof (double))) == NULL)
        {
            return -1;
        }

    }

    for (int i = 0; i < nr; ++i)
        for (int j = 0; j < i + 1; ++j)
            tm[i][j] = i * (i + 1) / 2 + j;

    for (int i = 0; i < nr; ++i)
    {
        for (int j = 0; j < i + 1; ++j)
            printf ("%f, ", tm[i][j]);
        printf ("\n");
    }

    tm[3][0] = 42.0;
    (*(tm + 3))[1] = 43.0;	// mi van, ha itt hiányzik a külső ()
    *(tm[3] + 2) = 44.0;
    *(*(tm + 3) + 3) = 45.0;

    for (int i = 0; i < nr; ++i)
    {
        for (int j = 0; j < i + 1; ++j)
            printf ("%f, ", tm[i][j]);
        printf ("\n");
    }

    for (int i = 0; i < nr; ++i)
        free (tm[i]);

    free (tm);

    return 0;
}]]></programlisting>
        <para>
            A program elején deklaráljuk az <varname>nr</varname> változót, ami az 5-ös értéket kapja,
            ez lesz a mátrix sorainak a száma. Ez után deklaráljuk a <varname>tm</varname> változót, aminek 
            lefoglaljuk a 8 bájtnyi táthelyet, majd ki iratjuk a memóriacímét. A <function>malloc</function> függvény
            memóriát foglal és egy pontert ad vissza amink mi  mondjuk meg mire mutasson. A <function>
                malloc</function> a <type>double *</type> helyigényét adja vissza ami 40 bájt. (nr * sizeof (double *))
            Egy <command>if</command>-fel megnézzük hohy le fogalta-e a helyet neki, ha igen a program tovább
            ha NULL-t kap program le áll.
        </para>
        <para>
            A első két for ciklusokban létrehozzuk a háromszögmátrixot, a harmadikkal ki iratjuk.
        </para>
        <para>
            A program utolsó részében a <function>free</function> függvényel felszabadítjuk tm által foglalt memóriát.
        </para>


        <para>
            Fordítás: <command>gcc fájlnév.c -o fájlnév</command> 
        </para>
        <para>
            Futtatás: <command>./fájlnév</command>
        </para>
        <figure>
            <title></title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/tm.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase></phrase>
                </textobject>
            </mediaobject>
        </figure>
        <figure>
            <title>A <type>double **</type> háromszögmátrix a memóriában</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/doublecscs.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>A <type>double **</type> háromszögmátrix a memóriában</phrase>
                </textobject>
            </mediaobject>
        </figure>                             
                   
    </section>        
    <section>
        <title>C EXOR titkosító</title>
        <para>
            Írj egy EXOR titkosítót C-ben!
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:                
        </para>
     
        <para>
            Forráskód linkje: <link xlink:href="https://gitlab.com/tamas.simon12/bhax/blob/master/Forrasok/4.%20Fejezet/exortitkosito.c">../bhax/blob/master/Forrasok/4.%20Fejezet/exortitkosito.c</link>
        </para>
        <para>
            Az exor titkosító az exor művelet segítségevel titkosít. A program a beolvasott szöveg és a kulcs bitjein hajtja végre a xor műveletet. Így az olvasható szövegből egy 
            sor értelmezhetetlen szimbolum kombinációt kapunk titkos szövegnek.
        </para>  
        <para>
            
        </para>
        <programlisting language="c"><![CDATA[#include <stdio.h>
#include <unistd.h>
#include <string.h>

#define MAX_KULCS 100
#define BUFFER_MERET 256


int
main (int argc, char **argv)
{

  char kulcs[MAX_KULCS];
  char buffer[BUFFER_MERET];

  int kulcs_index = 0;
  int olvasott_bajtok = 0;

  int kulcs_meret = strlen (argv[1]);
  strncpy (kulcs, argv[1], MAX_KULCS);

  while ((olvasott_bajtok = read (0, (void *) buffer, BUFFER_MERET)))
    {

      for (int i = 0; i < olvasott_bajtok; ++i)
	{

	  buffer[i] = buffer[i] ^ kulcs[kulcs_index];
	  kulcs_index = (kulcs_index + 1) % kulcs_meret;

	}

      write (1, buffer, olvasott_bajtok);

    }
}]]></programlisting>  
        <para>
            Fordítás: <command>gcc fájlnév.c -o fájlnév</command> 
        </para>
        <para>
            Futtatás: <command>./fájlnév kulcs &lt;tiszta.txt&gt; titkos.szoveg</command> (a kulcs bármi lehet)
        </para>  
        <figure>
            <title></title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/titkosc.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase></phrase>
                </textobject>
            </mediaobject>
        </figure>    
              
    </section>  
    
                
    <section>
        <title>Java EXOR titkosító</title>
        <para>
            Írj egy EXOR titkosítót Java-ban!
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://www.tankonyvtar.hu/hu/tartalom/tkt/javat-tanitok-javat/ch01.html#exor_titkosito">https://www.tankonyvtar.hu/hu/tartalom/tkt/javat-tanitok-javat/ch01.html#exor_titkosito</link>               
        </para>
     
        <para>
            Forráskód linkje: <link xlink:href="https://gitlab.com/tamas.simon12/bhax/blob/master/Forrasok/4.%20Fejezet/exortitkosito.java">../bhax/blob/master/Forrasok/4.%20Fejezet/exortitkosito.java</link>
        </para> 
        <para>
            A követekző java program egy titkosító és törő is egyben. A program ugyan úgy mint az előző C programban is a kizáró vagy művelet segítségével titkosít,itt 
            jön létre az szimbólumokból álló szöveg és tör, mikor a szöveget éjra olvashatóvá alakítja.
        </para>
        <para>
            A program olvassa a bemenetet bitenként majd a neki megfelelő kulcs bittel végrehajtja a kizáró vagy műveletet, majd tovább lépteti a  <varname>kulcsIndex</varname>-et
            Az eredmény a buffer tömbjébe kerül, ez lesz kiiratva program végén.
        </para>
        <para>
            Ahhoz hogy titkos szöveget feltörjük újra lefuttatjuk a programot, ekkor a titkos szövegbeli szimbólumok bitjaiet és a neki megfelelő kulcs bitet ossze xorozva a 
            szöveg "életre kel", vagyis a latin ABC betűit kapjuk vissza.
        </para>
        <programlisting language="c">
<![CDATA[public class exortitkosito {
    
    public exortitkosito(String kulcsSzöveg,
            java.io.InputStream bejövőCsatorna,
            java.io.OutputStream kimenőCsatorna)
            throws java.io.IOException {
        
        byte [] kulcs = kulcsSzöveg.getBytes();
        byte [] buffer = new byte[256];
        int kulcsIndex = 0;
        int olvasottBájtok = 0;

        while((olvasottBájtok =
                bejövőCsatorna.read(buffer)) != -1) {
            
            for(int i=0; i<olvasottBájtok; ++i) {
                
                buffer[i] = (byte)(buffer[i] ^ kulcs[kulcsIndex]);
                kulcsIndex = (kulcsIndex+1) % kulcs.length;
                
            }
            
            kimenőCsatorna.write(buffer, 0, olvasottBájtok);
            
        }
        
    }
    
    public static void main(String[] args) {
        
        try {
            
            new exortitkosito(args[0], System.in, System.out);
            
        } catch(java.io.IOException e) {
            
            e.printStackTrace();
            
        }
        
    }
    
}]]> 
        </programlisting>
        <para>
            A program futtatása 
        </para>
        <para> 
            <command>javac fájlnév.java</command> 
        </para> 
        <para>
            <command>java fájlnév kulcs &gt;  titkositott.txt</command> - a titkosítandó szöveg beolvasása, a kulcs bármi lehet, egyeznie kell majd a töréshez használt kulccsal
        </para>
        <para>
            <command>more titkositott.txt</command> - a titkos szöveg
        </para>  
        <para>
            <command>java fájlnév kulcs &lt;  titkositott.txt</command> - dekódoljuk a titkosított szöveget, visszakapva az eredetit
        </para> 
        <figure>
            <title></title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/titkosjava.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase></phrase>
                </textobject>
            </mediaobject>
        </figure>
          
    </section>        
    <section xml:id="bhax-textbook-feladatok-caesar.EXOR-toro">
        <title>C EXOR törő</title>
        <para>
            Írj egy olyan C programot, amely megtöri az első feladatban előállított titkos szövegeket!
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:                
        </para>
       
        <para>
            Forráskód linkje: <link xlink:href="https://gitlab.com/tamas.simon12/bhax/blob/master/Forrasok/4.%20Fejezet/exortoro.c">../bhax/blob/master/Forrasok/4.%20Fejezet/exortoro.c</link>
        </para> 
        <programlisting language="c">
<![CDATA[#define MAX_TITKOS 4096
#define OLVASAS_BUFFER 256
#define KULCS_MERET 8
#define _GNU_SOURCE

#include <stdio.h>
#include <unistd.h>
#include <string.h>

double
atlagos_szohossz (const char *titkos, int titkos_meret)
{
  int sz = 0;
  for (int i = 0; i < titkos_meret; ++i)
    if (titkos[i] == ' ')
      ++sz;

  return (double) titkos_meret / sz;
}

int
tiszta_lehet (const char *titkos, int titkos_meret)
{
  // a tiszta szoveg valszeg tartalmazza a gyakori magyar szavakat
  // illetve az átlagos szóhossz vizsgálatával csökkentjük a
  // potenciális töréseket

  double szohossz = atlagos_szohossz (titkos, titkos_meret);

  return szohossz > 6.0 && szohossz < 9.0
    && strcasestr (titkos, "hogy") && strcasestr (titkos, "nem")
    && strcasestr (titkos, "az") && strcasestr (titkos, "ha");

}

void
exor (const char kulcs[], int kulcs_meret, char titkos[], int titkos_meret)
{

  int kulcs_index = 0;

  for (int i = 0; i < titkos_meret; ++i)
    {

      titkos[i] = titkos[i] ^ kulcs[kulcs_index];
      kulcs_index = (kulcs_index + 1) % kulcs_meret;

    }

}

int
exor_tores (const char kulcs[], int kulcs_meret, char titkos[],
	    int titkos_meret)
{

  exor (kulcs, kulcs_meret, titkos, titkos_meret);

  return tiszta_lehet (titkos, titkos_meret);

}

int
main (void)
{

  char kulcs[KULCS_MERET];
  char titkos[MAX_TITKOS];
  char *p = titkos;
  int olvasott_bajtok;

  // titkos fajt berantasa
  while ((olvasott_bajtok =
	  read (0, (void *) p,
		(p - titkos + OLVASAS_BUFFER <
		 MAX_TITKOS) ? OLVASAS_BUFFER : titkos + MAX_TITKOS - p)))
    p += olvasott_bajtok;

  // maradek hely nullazasa a titkos bufferben  
  for (int i = 0; i < MAX_TITKOS - (p - titkos); ++i)
    titkos[p - titkos + i] = '\0';

  // osszes kulcs eloallitasa
  for (int ii = '0'; ii <= '9'; ++ii)
    for (int ji = '0'; ji <= '9'; ++ji)
      for (int ki = '0'; ki <= '9'; ++ki)
	for (int li = '0'; li <= '9'; ++li)
	  for (int mi = '0'; mi <= '9'; ++mi)
	    for (int ni = '0'; ni <= '9'; ++ni)
	      for (int oi = '0'; oi <= '9'; ++oi)
		for (int pi = '0'; pi <= '9'; ++pi)
		  {
		    kulcs[0] = ii;
		    kulcs[1] = ji;
		    kulcs[2] = ki;
		    kulcs[3] = li;
		    kulcs[4] = mi;
		    kulcs[5] = ni;
		    kulcs[6] = oi;
		    kulcs[7] = pi;

		    if (exor_tores (kulcs, KULCS_MERET, titkos, p - titkos))
		      printf
			("Kulcs: [%c%c%c%c%c%c%c%c]\nTiszta szoveg: [%s]\n",
			 ii, ji, ki, li, mi, ni, oi, pi, titkos);

		    // ujra EXOR-ozunk, igy nem kell egy masodik buffer  
		    exor (kulcs, KULCS_MERET, titkos, p - titkos);
		  }

  return 0;
}]]> 
        </programlisting>
        <para>
            A programban a <function>tiszta_lehet</function> függvény megpróbálja megtippelni, hogy a kapott szöveg tartalmazza-e a leggyakoribb magyar szavakat (hogy, nem, az, 
            ha), mivel ezek használata nélkül nem igazán alkotható értelmes magyar nyelvű szöveg. Az átlag szóhossz vizsgálatával csökkntjük a potenciális töréseket.
   
        </para>
        <para>
            Az <function>exor_toro</function> függvény a benne lévő <function>exor</function> függvény segíttségével elvégzi a kizáró vagyos műveletet a titkos szöveg és kulcs
            között, kihasznalva az exor müvelet azon tulajdonságágt hogy ha valamit kétszer exorozunk az eredmény egyenlő az eredeti értékkel. E tulajdonságot felhasználva állítja
            vissza az erdtei szöveget.
        </para>
        <para>
            A mainnel belül a program elő állítja a kulcsot majd elvégzi az exor műveletet.
        </para>
        <para>
            Fordítás: <command>gcc fájlnév.c -o fájlnév -std=c99</command> 
        </para>
        <para>
            Futtatás: <command>./fájlnév &lt;titkos.szoveg |grep kulcs</command> (a kulcsnak meg kell egyeznie a titkosítási kulccsal)
        </para>
        <figure>
            <title></title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/tores.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase></phrase>
                </textobject>
            </mediaobject>
        </figure>
        
        
        <para>
            Fordítás: <command>gcc fájlnév.c -O3 -o fájlnév -std=c99</command> 
        </para>
        <para>
            Futtatás: <command>./fájlnév &lt;titkos.szoveg |grep 56789012</command>
        </para>
        <figure>
            <title></title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/toresO3.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase></phrase>
                </textobject>
            </mediaobject>
        </figure>
    </section>        
    <section>
        <title>Neurális OR, AND és EXOR kapu</title>
        <para>
            R
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/Koyw6IH5ScQ">https://youtu.be/Koyw6IH5ScQ</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/NN_R">https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/NN_R</link>               
        </para>
        
        <para>
            Forráskód linkje: <link xlink:href="https://gitlab.com/tamas.simon12/bhax/blob/master/Forrasok/4.%20Fejezet/nn.r">../bhax/blob/master/Forrasok/4.%20Fejezet/nn.r</link>
        </para> 
        <para>
            Az alábbi feladatokban megtanítjuk egy neuronnak az OR, AND és EXOR műveleteket, mindezeket R-ben. 
        </para>
        <programlisting language="c">
<![CDATA[#   Copyright (C) 2019  Dr. Norbert Bátfai, nbatfai@gmail.com
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>
#
# https://youtu.be/Koyw6IH5ScQ

library(neuralnet)

a1    <- c(0,1,0,1)
a2    <- c(0,0,1,1)
OR    <- c(0,1,1,1)

or.data <- data.frame(a1, a2, OR)

nn.or <- neuralnet(OR~a1+a2, or.data, hidden=0, linear.output=FALSE, stepmax = 1e+07, threshold = 0.000001)

plot(nn.or)

compute(nn.or, or.data[,1:2])]]>
        </programlisting>

        <para>
            OR, azaz ligikai megengedő vagy. Megadunk két értéket(a1,a2) és azt hogy a vagy műveletet végre hajtva milyen eredmény kell ki jöjjön(OR). Az eredményt 143 lépésből 
            kapjuk.
        </para>
        <figure>
            <title>Neurális OR</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/Ror.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>Neurális OR</phrase>
                </textobject>
            </mediaobject>
        </figure>

        <programlisting language="c">
<![CDATA[a1    <- c(0,1,0,1)
a2    <- c(0,0,1,1)
OR    <- c(0,1,1,1)
AND   <- c(0,0,0,1)

orand.data <- data.frame(a1, a2, OR, AND)

nn.orand <- neuralnet(OR+AND~a1+a2, orand.data, hidden=0, linear.output=FALSE, stepmax = 1e+07, threshold = 0.000001)

plot(nn.orand)

compute(nn.orand, orand.data[,1:2])]]>
        </programlisting>
        <para>
            Ha az OR mellet felhasználjuk azt AND, vagyis logikai és műveletet, ugyan úgy mgadjuk a két értéket és azt hogy milyen eredményz akarunk kapni.
            Az eredményt 214 lépésben kapjuk.
        </para>
        <figure>
            <title>Neurális AND</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/Rorand.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>Neurális AND</phrase>
                </textobject>
            </mediaobject>
        </figure>



        <programlisting language="c">
<![CDATA[a1      <- c(0,1,0,1)
a2      <- c(0,0,1,1)
EXOR    <- c(0,1,1,0)

exor.data <- data.frame(a1, a2, EXOR)

nn.exor <- neuralnet(EXOR~a1+a2, exor.data, hidden=0, linear.output=FALSE, stepmax = 1e+07, threshold = 0.000001)

plot(nn.exor)

compute(nn.exor, exor.data[,1:2])]]>
        </programlisting>
        <para>
            Az EXOR, azaz logikai kizáró vagy. Ugyan úgy mint az előző két feladatban itt is megadjuk az értékeket, és hibát tapasztaunk, mivel 108 lépés alatt,
            0,5 a hibák aránya. Ezért szükség van rejtett rétegekre, ezt mutatja a következő példa.
        </para>
        <figure>
            <title>Neurális EXOR</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/Rexor1.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>Neurális EXOR</phrase>
                </textobject>
            </mediaobject>
        </figure>


        <programlisting language="c">
<![CDATA[a1      <- c(0,1,0,1)
a2      <- c(0,0,1,1)
EXOR    <- c(0,1,1,0)

exor.data <- data.frame(a1, a2, EXOR)

nn.exor <- neuralnet(EXOR~a1+a2, exor.data, hidden=c(6, 4, 6), linear.output=FALSE, stepmax = 1e+07, threshold = 0.000001)

plot(nn.exor)

compute(nn.exor, exor.data[,1:2])]]>
        </programlisting>
        <para>
            A hozzá adott rétegek segítségével 73 lépés alatt kapnk eredményt. 
        </para>
        <figure>
            <title>Neurális EXOR</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/Rexor3.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>Neurális EXOR</phrase>
                </textobject>
            </mediaobject>
        </figure>
        <para>
            Mivel ezek szimulációk megesik olyan is hogy 60 lépés alatt kaptunk helyes eredményt, 0 hibával.
        </para>
        <figure>
            <title>Neurális EXOR</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/Rexor2.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>Neurális EXOR</phrase>
                </textobject>
            </mediaobject>
        </figure>
    </section>        
    <section>
        <title>Hiba-visszaterjesztéses perceptron</title>
        <para>
            C++
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/XpBnR31BRJY">https://youtu.be/XpBnR31BRJY</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://github.com/nbatfai/nahshon/blob/master/ql.hpp#L64">https://github.com/nbatfai/nahshon/blob/master/ql.hpp#L64</link>               
        </para>
        
        <para>
            Forráskód linkje: <link xlink:href="https://gitlab.com/tamas.simon12/bhax/blob/master/Forrasok/4.%20Fejezet/mlp.hpp">
                ../bhax/blob/master/Forrasok/4.%20Fejezet/mlp.hpp</link>
        </para>   
        <para>
            Fordítás <command>g++ mlp.hpp main.cpp -o perc -lpng -std=c++11</command>
        </para>
        <para>
            Futtatás <command>./perc mandel.png</command>
        </para>  
        <para>
            A perceptron egy algoritmus a gépi tanulásban.
        </para>
        <para>
            A main függvényen belül a size változóban tároljuk a megadott kép méretét, majd létrehozunk egy új prceptront aminek 3 rétege lesz, az első a kép pixeleinek száma.
            A második réteg 256, a harmadik 1.A perceptron a pixelek piros árnyalatait tárolja. A perceptron a számolások elvégzése után a standart kimenetre írja az eredményt.
            
        </para>
     
    </section>        
        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
</chapter>                
